module IDE.Common where

import UI.Widgets.Common
import Common
import Interpreter.Common

data EditAction
  = Cut
  | Copy
  | Paste
  | SelectAll
  deriving Show

data IDEEvent
  = IDETerminalEvent TerminalEvent
  | IDEReqEditorContent
  | IDEParseErrorUpdate (Maybe (Location, Text))
  | IDEACUpdateIdentifiers [Text]
  | IDEClearDraw
  | IDEDraw
  | IDEToggleHelp
  | IDEToggleOutput
  | IDESave
  | IDEExit
  | IDEEdit EditAction
  | IDEBeautify
  | IDEClearLog
  | IDEClearOutput
  | IDEAppendLog Text
  | IDEStep
  | IDEStop
  | IDEShowAbout
  | IDEHideAbout
  | IDEDebugUpdate (Maybe DebugState)
  | IDERun
  deriving Show
